<template>
  <v-autocomplete
    ref="autocomplete"
    v-model="model"
    :items="items"
    :label="label"
    :density="density"
    variant="outlined"
    :item-value="itemValue"
    :item-title="itemTitle"
    :return-object="returnObject"
    hide-details
    clearable
    clear-icon="mdi-close"
    :color="color"
    :base-color="baseColor"
    :multiple="multiple"
    :menu-props="menuProps"
    :disabled="disabled"
    :clear-on-select="clearOnSelect"
    :closable-chips="closableChips"
    :prepend-inner-icon="prependInnerIcon"
    class="min-w-[208px] max-w-[400px] input"
    :class="overflowY ? 'py-2 overflow-y-auto' : null"
    @update:model-value="update"
    @input="setSearch"
    @click:clear="clear"
    @focusout="removeModel"
  >
    <template
      v-if="!checkbox"
      #item="{ props, item }"
    >
      <v-list-item
        v-bind="props"
        :value="item"
        :disabled="disablingFunction(item?.value)"
      >
        <template v-if="avatar" #prepend>
          <slot name="prepend-details" :item="item">
            <svn-avatar
              :size="'md'"
              :firstname="item?.raw?.firstname"
              :lastname="item?.raw?.lastname"
              :avatar="item?.raw?.avatar?.['30'] || item?.raw?.avatar"
            />
          </slot>
        </template>

        <template #default>
          <slot name="main-content" :item="item">
            <svn-text base regular color="fake-black" >
              {{ item?.raw?.job_title }}
            </svn-text>
          </slot>
        </template>

        <template #append>
          <slot name="append-content" :item="item">
            <div v-if="withAddAndRemoveButtons">
              <svn-button
                v-if="disablingFunction(item?.value)"
                variant="none"
                prepend-icon="mdi-check"
                prepend-class="text-green"
              >
                <template #button-text>
                  <svn-text sm color="green" class="uppercase">
                    {{ "Added" }}
                  </svn-text>
                </template>
              </svn-button>
  
              <svn-button
                v-else
                variant="none"
                prepend-icon="mdi-plus"
                prepend-class="text-primary"
              >
                <template #button-text>
                  <svn-text sm color="primary" class="uppercase">
                    {{ ("Add") }}
                  </svn-text>
                </template>
              </svn-button>
            </div>
          </slot>
        </template>
      </v-list-item>
    </template>

    <template #chip="{ item }">
      <slot name="chip-content" :item="item" :props="props">
        <!-- Une chip composée d'un fullname -->
        <v-chip
          v-if="multiple && !avatarChip"
          v-bind="props"
          :key="item.value"
          :close-icon="closeIcon"
          variant="outlined"
          :color="color"
          class="!text-dark-grey mx-[2px]"
          :class="chipClass"
          @click:close="removeItem(item)"
        />

        <!-- Une chip composée d'un avatar et d'un fullname -->
        <v-chip
          v-else-if="multiple && avatarChip"
          closable
          variant="outlined"
          :close-icon="closeIcon"
          size="large"
          :color="color"
          :class="chipClass"
          @click:close="removeItem(item.value)"
        >
          <div class="w-full flex items-center gap-2">
            <svn-avatar
              v-if="avatar"
              :size="'sm'"
              :firstname="item?.raw?.firstname"
              :lastname="item?.raw?.lastname"
              :avatar="item?.raw?.avatar || item?.raw?.avatar?.['30']"
            />

            <svn-text base regular>
              {{ item?.raw?.fullname }}
            </svn-text>
          </div>
        </v-chip>

        <!-- Un avatar et/ou un fullname mais pas dans une chip -->
        <div v-else class="w-full flex items-center gap-2">
          <svn-avatar
            v-if="avatar"
            :size="'sm'"
            :firstname="item?.raw?.firstname || item?.raw?.fullname"
            :lastname="item?.raw?.lastname || ''"
            :avatar="item?.raw?.avatar || item?.raw?.avatar?.['30']"
          />

          <svn-text base regular>
            {{ item?.raw?.[itemTitle] }}
          </svn-text>
        </div>
      </slot>
    </template>

    <template #no-data>
      <slot name="no-data">
        <div
          v-if="loading"
          class="flex flex-col justify-center items-center"
        >
          <svn-loader loading-size="lg"/>
        </div>

        <div
          v-else
          class="flex flex-col justify-center items-center"
        >
          <svn-text base >
            {{ 'No element found, please try again !' }}
          </svn-text>
        </div>
      </slot>
    </template>

    <template #append-item>
      <div v-intersect="onIntersect" />
    </template>
  </v-autocomplete>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import SvnAvatar from '../avatar/SvnAvatar.vue';
import { debounce } from "lodash";

const props = defineProps({
  modelValue: { type: undefined, default: null },
  menuProps: { type: Object, default: () => {} },
  items: { type: Array, default: () => [] },
  itemTitle: { type: String, default: 'fullname' },
  itemValue: { type: undefined, default: 'id' },
  label: { type: String, default: '' },
  density: { type: String, default: 'compact' },
  color: { type: String, default: "darkGrey" },
  overflowY: { type: Boolean, default: true },
  checkbox: { type: Boolean, default: false },
  multiple: { type: Boolean, default: false },
  prependInnerIcon: { type: String, default: 'mdi-magnify' },
  closableChips: { type: Boolean, default: false },
  disabled: { type: Boolean, default: false },
  avatar: { type: Boolean, default: false },
  avatarChip: { type: Boolean, default: false },
  closeIcon: { type: String, default: 'mdi-close' },
  disablingFunction: { type: Function, default: () => { return false } },
  clearOnSelect: { type: Boolean, default: false },
  loading: { type: Boolean, default: false },
  withAddAndRemoveButtons: { type: Boolean, default: false },
  returnObject: { type: Boolean, default: false },
  chipClass: { type: String, default: '!rounded-lg'},
  baseColor: { type: String, default: 'middleGrey' },
});

onMounted(() => {
  model.value = props?.modelValue
});

const searched = ref('');
const model = ref(null);
const autocomplete = ref(null);

const emit = defineEmits(['update:modelValue', 'on-intersect', 'intersect', 'input', 'clear'])

const update = () => {
  emit('update:modelValue', model?.value)
}

const clear = () => {
  emit('clear');
}

const removeModel = () => {
  if (props.clearOnSelect) {
    model.value = null
  }
}

const onIntersect = (isIntersecting, entries, observer) => {
  if (isIntersecting) {
    emit('intersect');
  }
}

const removeItem = (itemId) => {
  let filteredModelValue

  if (typeof itemId === 'number') {
    filteredModelValue = model?.value?.filter(elementId => elementId != itemId)

  } else if (typeof itemId === 'object') {
    filteredModelValue = model?.value?.filter(elementId => elementId != itemId.value)
  }
  model.value = filteredModelValue

  emit('update:modelValue', model?.value)
}

const setSearch = debounce((e) => {
  searched.value = e.target.value;

  emit('input', searched.value);
}, 300)
</script>

<style scoped>
.input :deep(.v-field) {
  border-radius: 8px;
  background: white;
}

.input :deep(.v-field__input) {
  min-height: 48px;
}

/* .input :deep(.v-input__control) {
  height: 48px;
} */


* :deep(.v-input__control) {
  width: 100%;
}

</style>
